
var BBUInfo = new Object();
BBUInfo.HBAID = 0;
BBUInfo.oModify = null;
BBUInfo.oRestore = null;
BBUInfo.oTempUpper = null;
BBUInfo.oTempLower = null;
BBUInfo.oVolUpper = null;
BBUInfo.oVolLower = null;
BBUInfo.sTempUpper = 0;
BBUInfo.sTempLower = 0;
BBUInfo.sVolUpper = 0;
BBUInfo.sVolLower = 0;
BBUInfo.suTempUpper = -1;
BBUInfo.suTempLower = -1;
BBUInfo.suVolUpper = -1;
BBUInfo.suVolLower = -1;
BBUInfo.supportVol = 0;
BBUInfo.supportTemp = 0;
BBUInfo.errMsg = "";
BBUInfo.oErrFocus = null;
BBUInfo.MSG_UPPER_LESS_THAN_LOWER = "Upper value should larger than lower!";
BBUInfo.MSG_RANGE_BE_NUMBER = "Range value should be number and larger than 0!";

BBUInfo.scheduleRelearn = function()
{
	
    var URL = "JumpPage.php?Target=BBUSchedulePage&VDID="+0    //only one bbu
		+"&HBAID="+BBUInfo.HBAID
		//+"&VdNotOnDg="+InitPage.VdNotOnDg
    	+"&bgaType="+50
    	+"&type=bgaSave"
		+"&subBtnTplName=SubBtn_BBUOp_OpEnabled.tpl"
    	+"&bgaPage=getBBUSubPage"
		+"&scheduleClass=bbu";
    	
    MarvellRaidDetail.runUrl(URL);
}

BBUInfo.changeStatus = function()
{
    if (BBUInfo.supportTemp)
    {
        BBUInfo.suTempUpper = BBUInfo.oTempUpper.value;
        BBUInfo.suTempLower = BBUInfo.oTempLower.value;
    }
    if (BBUInfo.supportVol)
    {
        BBUInfo.suVolUpper = BBUInfo.oVolUpper.value;
        BBUInfo.suVolLower = BBUInfo.oVolLower.value;
    }
    BBUInfo.hasModified=true;

    BBUInfo.oModify.className="buttonChar";
    BBUInfo.oModify.onclick=BBUInfo.doModify;
    BBUInfo.oRestore.className="buttonChar";
    BBUInfo.oRestore.onclick=BBUInfo.doRestore;
}

BBUInfo.doModify = function()
{
    if (BBUInfo.hasModified)
    {
        if (BBUInfo.checkPage())
        {
            BBUInfo.modifiedClean();
            var strCmd = "command.php?cmdName=saveBBUConfig&HBAID="+BBUInfo.HBAID;

            if (BBUInfo.supportVol && BBUInfo.suVolUpper != -1 && BBUInfo.suVolLower != -1)
            {
                strCmd += "&VolUpper="+BBUInfo.suVolUpper+"&VolLower="+BBUInfo.suVolLower;
            }
            
            if (BBUInfo.supportTemp && BBUInfo.suTempUpper != -1 && BBUInfo.suTempLower != -1)
            {
                strCmd += "&TempUpper="+BBUInfo.suTempUpper+"&TempLower="+BBUInfo.suTempLower;
            }

            var setConfigCMD= new Command(strCmd);
            setConfigCMD.run();
            var result = setConfigCMD.getResult();
            if (result != "")
            {
                MarvellRaidDetail.partUrl = result;
                MarvellRaidDetail.run();
            }
            setConfigCMD=null;
        }else{
            if (BBUInfo.oErrFocus != null) focusAndSel(BBUInfo.oErrFocus);
            if (BBUInfo.errMsg != "") alert(BBUInfo.errMsg);
        }
    }
    return false;

}

BBUInfo.checkPage = function()
{
    if (BBUInfo.supportVol)
    {
        if (isNaN(BBUInfo.suVolUpper) || BBUInfo.suVolUpper < 0)
        {
            BBUInfo.oErrFocus = BBUInfo.oVolUpper;
            BBUInfo.errMsg = BBUInfo.MSG_RANGE_BE_NUMBER;

            return false;
        }
        if (isNaN(BBUInfo.suVolLower) || BBUInfo.suVolLower < 0)
        {
            BBUInfo.oErrFocus = BBUInfo.oVolLower;
            BBUInfo.errMsg = BBUInfo.MSG_RANGE_BE_NUMBER;

            return false;
        }
    }
    if (BBUInfo.supportTemp)
    {
        if (isNaN(BBUInfo.suTempUpper) || BBUInfo.suTempUpper < 0)
        {
            BBUInfo.oErrFocus = BBUInfo.oTempUpper;
            BBUInfo.errMsg = BBUInfo.MSG_RANGE_BE_NUMBER;

            return false;
        }
        if (isNaN(BBUInfo.suTempLower) || BBUInfo.suTempLower < 0)
        {
            BBUInfo.oErrFocus = BBUInfo.oTempLower;
            BBUInfo.errMsg = BBUInfo.MSG_RANGE_BE_NUMBER;

            return false;
        }
    }
    if (BBUInfo.suVolUpper < BBUInfo.suVolLower) 
    {
        BBUInfo.errMsg=BBUInfo.MSG_UPPER_LESS_THAN_LOWER;
        BBUInfo.oErrFocus = BBUInfo.oVolUpper;
        return false;
    }

    if (BBUInfo.suTempUpper < BBUInfo.suTempLower) 
    {
        BBUInfo.errMsg=BBUInfo.MSG_UPPER_LESS_THAN_LOWER;
        BBUInfo.oErrFocus = BBUInfo.oTempUpper;
        return false;
    }
    return true;
}

BBUInfo.modifiedClean=function()
{
    BBUInfo.oModify.onclick=doNothing;
    BBUInfo.oRestore.onclick=doNothing;
    BBUInfo.oModify.className="disButtChar";
    BBUInfo.oRestore.className="disButtChar";

    BBUInfo.hasModified=false;
}

BBUInfo.doRestore = function()
{
    if (BBUInfo.hasModified)
    {
        BBUInfo.modifiedClean();

        if (BBUInfo.supportVol)
        {
            BBUInfo.oVolUpper.value = BBUInfo.sVolUpper;
            BBUInfo.oVolLower.value = BBUInfo.sVolLower;
        }
        if (BBUInfo.supportTemp)
        {
            BBUInfo.oTempUpper.value = BBUInfo.sTempUpper;
            BBUInfo.oTempLower.value = BBUInfo.sTempLower;
        }
    }
    return false;
}

BBUInfo.setXMLresult = function()
{
    if (BBUInfo.xml != null)
    {
        ContentLoader.runScript(BBUInfo.xml.responseText);
        if (BBUInfo.oBBUInfoBody)
        {
            BBUInfo.oBBUInfoBody.innerHTML = BBUInfo.xml.responseText;
        }
    }
    ContentLoader.returnBack(BBUInfo.xml);
    BBUInfo.xml=null;
}

BBUInfo.refreshStatus = function(){

    var urlPath = "JumpPage.php?ra="+RefreshControl.getSeq()+"&Target=getBBUInfo&HBAID="+BBUInfo.HBAID;

    ContentLoader.loadXMLDoc(BBUInfo,urlPath);
    
    urlPath=null;
}

function BBUDetailPage(){
    BBUInfo.oModify = getObjectById("modifyBtn");
    BBUInfo.oRestore = getObjectById("restoreBtn");
    //BBUInfo.oStatusLabel = getObjectById("statusLabel");
    BBUInfo.oBBUInfoBody = getObjectById("bbuInfo");

    if (BBUInfo.supportVol)
    {
        BBUInfo.oVolUpper = getObjectById("volUpper");
        BBUInfo.oVolLower = getObjectById("volLower");
        BBUInfo.sVolUpper = BBUInfo.oVolUpper.value;
        BBUInfo.sVolLower = BBUInfo.oVolLower.value;

    }
    if (BBUInfo.supportTemp)
    {
        BBUInfo.oTempUpper = getObjectById("tempUpper");
        BBUInfo.oTempLower = getObjectById("tempLower");
        BBUInfo.sTempUpper = BBUInfo.oTempUpper.value;
        BBUInfo.sTempLower = BBUInfo.oTempLower.value;
    }

	MarvellRaidTree.setCurrentNode("treelink_"+MarvellRaidTree.BBU_LEAF+BBUInfo.HBAID+BBUInfo.HBAID);

    LoopControl.removeLoop("BBUStatusRefresh");
    LoopControl.addLoop(BBUInfo.refreshStatus,"BBUStatusRefresh");
}