var BgaSchedule = new Object();

function BgaSchedulePage()
{
	BgaSchedule.initialize();

	BgaSchedule.hideJobID = getObjectById("selectedJobIDs");
	BgaSchedule.hideJobID.value = "";
	BgaSchedule.deleteBtn = getObjectById('deleteBtn');

	AddSplitterChangeResize(BgaSchedule.XMLResize);

	MarvellRaidTree.setCurrentNode("treelink_"+MarvellRaidTree.SYSTEM_LEAF+0+0);
	clickTreeNode(MarvellRaidTree.currentNode);

	//modify cookie to avoid post iterative
	var newUrl='JumpPage.php?Target=BgaSchedulePage&TreeNodeType='+MarvellRaidTree.currentNode;
	newUrl = newUrl.replace(/=/g, ':');
	document.cookie=MarvellRaidDetail.reqID+"="+newUrl;

}

BgaSchedule.initialize=function(){
	BgaSchedule.hideJobID = null;
	BgaSchedule.deleteBtn = null;
	checkBoxNum = 0;
}

function unBgaSchedulePage()
{
	BgaSchedule.initialize();
}

var checkBoxNum = 0;
BgaSchedule.doClickCheckBox = function(checkBoxID)
{
	TheCheckBox = document.getElementById(checkBoxID);
	if(TheCheckBox.checked)
	{
		BgaSchedule.doAdd(checkBoxID);
		BgaSchedule.deleteBtn.className = "buttonChar";
		BgaSchedule.deleteBtn.onclick = BgaSchedule.doDelete;
		checkBoxNum++;
	}
	else
	{
		BgaSchedule.doRemove(checkBoxID);
		checkBoxNum--;
		if (checkBoxNum < 1)
		{
		    BgaSchedule.deleteBtn.className = "disButtChar";
		    BgaSchedule.deleteBtn.onclick = "";
		}
	}
}

BgaSchedule.doAdd = function(checkBoxID)
{
	var jobIDs = BgaSchedule.hideJobID.value;
	if(jobIDs.substring(jobIDs.length-1,jobIDs.length) != " ")
	{
		jobIDs = jobIDs + " " + checkBoxID;
	}
	else
	{
		jobIDs = jobIDs + " " + checkBoxID + " ";
	}
	BgaSchedule.hideJobID.value = jobIDs;
	//alert(jobIDs);
}

BgaSchedule.doRemove = function(checkBoxID)
{
	var jobIDs = BgaSchedule.hideJobID.value;
	
	if(jobIDs.substring(0,1) != " ")
	{
		jobIDs = " " + jobIDs;
	}
	if(jobIDs.substring(jobIDs.length-1,jobIDs.length) != " ")
	{
		jobIDs = jobIDs + " ";
	}
	
	var thisJobID = checkBoxID + " ";
	var thisJobIDLen = thisJobID.length;
	var jobIDsLen = jobIDs.length;
	var thisJobIDIndex = jobIDs.indexOf(checkBoxID);
	var newJobIDs = jobIDs.substring(0,thisJobIDIndex);
	thisJobIDIndex = thisJobIDIndex + thisJobIDLen;
	newJobIDs = newJobIDs + jobIDs.substring(thisJobIDIndex,jobIDsLen);
	//alert(newJobIDs);
	BgaSchedule.hideJobID.value = newJobIDs;
}

BgaSchedule.doDelete = function()
{
	BgaSchedule.deleteBtn.className = "disButtChar";
	BgaSchedule.deleteBtn.onclick = "";

	if (confirm("Are you sure you want to delete these bga schedule you selected?"))
	{ 
	   // actionForm.type.value = 'delete';
	    //actionForm.submit();
		var URL = "JumpPage.php?Target=BgaSchedulePage&type=delete&selectedJobIDs="+BgaSchedule.hideJobID.value;

		MarvellRaidDetail.runUrl(URL);

	} else {
		BgaSchedule.deleteBtn.className = "buttonChar";
		BgaSchedule.deleteBtn.onclick = BgaSchedule.doDelete;
	}
	return false;
}

BgaSchedule.doFirst = function()
{
	var URL = "JumpPage.php?Target=BgaSchedulePage&pageID=0" + "&ra=" + RefreshControl.getSeq();
	MarvellRaidDetail.runUrl(URL);
}

BgaSchedule.doNext = function(pageID)
{
	page = pageID + 1;
	var URL = "JumpPage.php?Target=BgaSchedulePage&pageID=" + page + "&ra=" + RefreshControl.getSeq();
	MarvellRaidDetail.runUrl(URL);
}

BgaSchedule.doPrevious = function(pageID)
{
	page = pageID - 1;
	var URL = "JumpPage.php?Target=BgaSchedulePage&pageID=" + page + "&ra=" + RefreshControl.getSeq();
	MarvellRaidDetail.runUrl(URL);
}

BgaSchedule.doLast = function()
{
	var URL = "JumpPage.php?Target=BgaSchedulePage&pageID=-1" + "&ra=" + RefreshControl.getSeq();
	MarvellRaidDetail.runUrl(URL);
}


BgaSchedule.goToNewSetTime = function(newJobID)
{
	var url = 'JumpPage.php?Target=TimeSettingPage&type=modify&pageID=0&selectedJobIDs=' + newJobID;
	window.open(url, '',  'width=600, height=350, resizable=0, depended=1, top=200, left=200');
}

BgaSchedule.goToSetTime = function(pageID)
{
	if(Alltrim(BgaSchedule.hideJobID.value) != "")
	{
		var url = 'JumpPage.php?Target=TimeSettingPage&type=modify&pageID=' + pageID + '&selectedJobIDs=' + Alltrim(BgaSchedule.hideJobID.value);
		window.open(url, '',  'width=600, height=350, resizable=0, depended=1, top=200, left=200');
	}
}

BgaSchedule.XMLResize = function() {
	//set scroll part height
	var ScrollPartObj = getObjectById("scheduleScrollPart");
	var TreeHtmlScrollBody = getObjectById("TreeHtmlScrollBody");
	var treeHeight = TreeHtmlScrollBody.style.height;
	treeHeight = treeHeight.slice(0, -2);
	var height=treeHeight - 79;
	if (height >= 0)
		ScrollPartObj.style.height = height;
	else 
		ScrollPartObj.style.height=0;
	//set table lists width
	var partWidth = getObjectById('bodyTbl').offsetWidth;

	for (i=0;i<BgaSchedule.listCount ;i++ )
	{
		getObjectById('cList'+i).width = getObjectById('cList_T').width = partWidth * 0.05;//23;//
		getObjectById('idList'+i).width = getObjectById('idList_T').width =partWidth * 0.05;// 32;//
		getObjectById('hbaidList'+i).width = getObjectById('hbaidList_T').width = partWidth * 0.12;//60;//
		getObjectById('classList'+i).width = getObjectById('classList_T').width = partWidth * 0.09;//45;//
		getObjectById('nameList'+i).width = getObjectById('nameList_T').width = partWidth * 0.27;//143;//
		getObjectById('setTimeList'+i).width = getObjectById('setTimeList_T').width = partWidth * 0.29;//153;//
		//getObjectById('startTimeList'+i).width = getObjectById('startTimeList_T').width = 80;//partWidth * 0.20;
	}

}

function clearCheckbox(cID)
{
	//alert(cID);
	cBox = getObjectById(cID);
	cBox.checked = false;
} 

//addResize(BgaSchedule.XMLResize);
addUnLoad(unBgaSchedulePage);
BgaSchedule.listCount=0;