
//Array info
var DgInfo = new Object();
DgInfo.ID=255;
DgInfo.HBAID = 255;
DgInfo.hasModified=false;
DgInfo.oModify=null;
DgInfo.oRestore=null;
DgInfo.oName=null;
DgInfo.iWriteCache=null;
DgInfo.MSG_NAME_INVALID = "Array name can only contain numbers, letters, spaces and underlines!";
DgInfo.autoRefresh=false;
DgInfo.subBtnVisible = 0;


DgInfo.setXMLresult = function()
{
    if (DgInfo.xml != null)
    {
		ContentLoader.runScript(DgInfo.xml.responseText);
		if (DgInfo.dynamicPart)
		{
			DgInfo.dynamicPart.innerHTML = DgInfo.xml.responseText;
		}
    }
    ContentLoader.returnBack(DgInfo.xml);
    DgInfo.xml=null;
}

DgInfo.dynamicRun = function(){
    var urlPath = "JumpPage.php?ra="+RefreshControl.getSeq()+"&Target=getArrayDynamicSubPage&ID="
					+DgInfo.ID+"&HBAID="+DgInfo.HBAID;
    ContentLoader.loadXMLDoc(DgInfo,urlPath);
    
    urlPath=null;
}

DgInfo.startAutoRefresh = function()
{
    if (false==DgInfo.autoRefresh)
    {
        ScriptDebug.writeLine("DgInfo.autoRefresh");
        DgInfo.autoRefresh=true;
        LoopControl.addLoop(DgInfo.dynamicRun,"DgInfoRefresh");
    }
}

DgInfo.stopAutoRefresh= function()
{
    if (true==DgInfo.autoRefresh)
    {
        ScriptDebug.writeLine("DgInfo.stopAutoRefresh");
        DgInfo.autoRefresh=false;
        LoopControl.removeLoop("DgInfoRefresh");
    }
}

DgInfo.changeStatus=function()
{
    DgInfo.hasModified=true;
	if (DgInfo.oModify)
	{
		DgInfo.oModify.className="buttonChar";
		DgInfo.oModify.onclick=DgInfo.doModify;
	}
	if (DgInfo.oRestore)
	{
		DgInfo.oRestore.className="buttonChar";
		DgInfo.oRestore.onclick=DgInfo.doRestore;
	}
}

DgInfo.modifiedClean=function()
{
	if (DgInfo.oModify)
	{
		DgInfo.oModify.onclick=doNothing;
		DgInfo.oModify.className="disButtChar";
	}
	if (DgInfo.oRestore)
	{
		DgInfo.oRestore.onclick=doNothing;
		DgInfo.oRestore.className="disButtChar";
	}
    DgInfo.hasModified=false;
}

DgInfo.doModify= function()
{
    if (CheckName(DgInfo.oName,DgInfo.MSG_NAME_INVALID) && DgInfo.hasModified)
    {
        DgInfo.modifiedClean();
        DgInfo.iWriteCache = getCheckedFromRadio("WriteCache");
        DgInfo.iName = DgInfo.oName.value;
        var setConfigCMD=new Command("command.php?cmdName=saveDgConfig&DGID="+DgInfo.ID+"&HBAID="+DgInfo.HBAID+"&WriteCacheOn="+DgInfo.iWriteCache+"&Name="+DgInfo.iName);
        setConfigCMD.run();
		var result = setConfigCMD.getResult();
		if (result != "")
		{
			MarvellRaidDetail.partUrl = result;
			MarvellRaidDetail.run();
		}
		MarvellRaidTree.run();
        setConfigCMD=null;
    }
    return false;
}

DgInfo.doRestore= function()
{
    if (DgInfo.hasModified)
    {
        DgInfo.modifiedClean();
		DgInfo.oName.value = DgInfo.iName;
        setCheckedToRadio("WriteCache",DgInfo.iWriteCache);
       // DgInfo.iuWriteCache=DgInfo.iWriteCache;
    }
    return false;
}

DgInfo.MSG_DELETE_CONFIRM="Are you sure you want to delete this Array?";
DgInfo.doDelete= function()
{
	if (confirm(DgInfo.MSG_DELETE_CONFIRM))
	{
		 var delCMD=new Command("command.php?cmdName=deleteDG&DGID="+DgInfo.ID+"&HBAID="+DgInfo.HBAID);
		delCMD.run();
		var result = delCMD.getResult();
		if (result != "")
		{
			MarvellRaidDetail.partUrl = result;
			MarvellRaidDetail.run();
		}
		delCMD=null;
		MarvellRaidTree.run();
	}
   
    return false;
}

DgInfo.doBGAStop=function()
{
    var stopCMD=new Command("command.php?cmdName=dgbgaControl&Action=stop&DGID="+DgInfo.ID+"&HBAID="+DgInfo.HBAID);
    stopCMD.run();
	var result = stopCMD.getResult();
	if (result != "")
	{
		MarvellRaidDetail.partUrl = result;
		MarvellRaidDetail.run();
	}
    stopCMD=null;
    return false;
}

DgInfo.doBGARestart=function()
{
    var restartCMD=new Command("command.php?cmdName=dgbgaControl&Action=restart&DGID="+DgInfo.ID+"&HBAID="+DgInfo.HBAID);
    restartCMD.run();
	var result = restartCMD.getResult();
	if (result != "")
	{
		MarvellRaidDetail.partUrl = result;
		MarvellRaidDetail.run();
	}
    restartCMD=null;
    return false;
}

DgInfo.doBGAPause=function()
{
    var pauseCMD=new Command("command.php?cmdName=dgbgaControl&Action=pause&DGID="+DgInfo.ID+"&HBAID="+DgInfo.HBAID);
    pauseCMD.run();
	var result = pauseCMD.getResult();
	if (result != "")
	{
		MarvellRaidDetail.partUrl = result;
		MarvellRaidDetail.run();
	}
    pauseCMD=null;
    return false;
}

DgInfo.doBGAResume=function()
{
    var resumeCMD=new Command("command.php?cmdName=dgbgaControl&Action=resume&DGID="+DgInfo.ID+"&HBAID="+DgInfo.HBAID);
    resumeCMD.run();
	var result = resumeCMD.getResult();
	if (result != "")
	{
		MarvellRaidDetail.partUrl = result;
		MarvellRaidDetail.run();
	}
    resumeCMD=null;
    return false;
}

var DgInfoOp = new Object();
DgInfoOp.operationXMLRun=function()
{
	var urlPath = "JumpPage.php?ra="+RefreshControl.getSeq()+"&Target=getArrayOperation&ID="
					+DgInfo.ID+"&HBAID="+DgInfo.HBAID+"&isVisible="+DgInfo.subBtnVisible;
	ContentLoader.loadXMLDoc(DgInfoOp,urlPath);

	urlPath=null;
}

DgInfoOp.setXMLresult= function()
{
    if (DgInfoOp.xml != null)
    {    	
        DgInfoOp.oOperationDiv.innerHTML = DgInfoOp.xml.responseText;
        ContentLoader.runScript(DgInfoOp.xml.responseText);
        
    }
    ContentLoader.returnBack(DgInfoOp.xml);
    DgInfo.xml=null;
}

DgInfoOp.removeXMLRun=function()
{
	RefreshControl.removeFunction(DgInfoOp.operationXMLRun);
	DgInfoOp.oOperationDiv=null;
}

DgInfo.transpObj = null;
function transDown() {
	if (DgInfo.transpObj)
	{
		DgInfo.transpObj.style.filter="alpha(opacity="+DgInfo.transpStartValue+")";
		DgInfo.transpObj.style.opacity=DgInfo.transpStartValue/100;
		DgInfo.transpTime = DgInfo.transpTime - 50;
		DgInfo.transpStartValue = DgInfo.transpStartValue - 1;
		if (DgInfo.transpTime <= 0){
			DgInfo.transpObj.style.display="none";
			clearInterval(DgInfo.transProcess);
		}
	} else {
		clearInterval(DgInfo.transProcess);
	}

}

function DgInfoPage(){
    DgInfo.oModify=getObjectById('modifyButt');
    DgInfo.oRestore=getObjectById('restoreButt');
	DgInfo.oName=getObjectById("DgName");
	DgInfo.dynamicPart=getObjectById("arrayDynamicPart");

	if (DgInfo.oName)
		DgInfo.iName=DgInfo.oName.value;
	DgInfo.iWriteCache=getCheckedFromRadio("WriteCache");
	
	DgInfoOp.oOperationDiv=getObjectById('arrayOpBtn');
    RefreshControl.addFunction(DgInfoOp.operationXMLRun,RefreshControl.ARRAY_EVENT|RefreshControl.LD_EVENT);

	MarvellRaidTree.setCurrentNode("treelink_"+MarvellRaidTree.ARRAY_LEAF+DgInfo.ID+DgInfo.HBAID);
	clickTreeNode(MarvellRaidTree.currentNode);

	DgInfo.startAutoRefresh();
}

DgInfo.initialize=function()
{
	DgInfo.ID = 255;
	DgInfo.HBAID = 255;
	DgInfo.hasModified=false;
	DgInfo.oModify=null;
	DgInfo.oRestore=null;
	DgInfo.oName=null;
	DgInfo.iWriteCache=null;

	DgInfo.stopAutoRefresh();
	DgInfo.autoRefresh=false;

	DgInfoOp.removeXMLRun();
}

function unDgInfoPage()
{
    DgInfo.oModify = null;
    DgInfo.oRestore = null;
    DgInfo.oName = null;
    DgInfo=null;
}

addUnLoad(unDgInfoPage);
