//ld list has 2 xml require. 1 is ld list list, 2 is event table

//LDList used to build ld list table
var LDList = new Object();

LDList.oDiv = null;
LDList.xml=null;
LDList.runBGA=false;

LDList.setXMLresult = function()
{
    if (LDList.xml != null)
    {
        LDList.oDiv.innerHTML = LDList.xml.responseText;
        //ld list get run/stop bga javascript
        ContentLoader.runScript(LDList.xml.responseText);
    }
    ContentLoader.returnBack(LDList.xml);
    LDList.xml=null;
}

LDList.run = function()
{
    //close IE cache
    var urlPath = "JumpPage.php?ra="+RefreshControl.getSeq()+"&Target=getLdList";
    ContentLoader.loadXMLDoc(LDList,urlPath);
    urlPath=null;
}

LDList.eventListener = function()
{
    if (false==LDList.runBGA)
    {LDList.run();}
}

LDList.startBGA= function()
{
    if (false==LDList.runBGA)
    {
        ScriptDebug.writeLine("LDList.startBGA");
        LDList.runBGA=true;
        LoopControl.addLoop(LDList.run,"LDListBGA");
    }
}

LDList.stopBGA= function()
{
    if (true==LDList.runBGA)
    {
        ScriptDebug.writeLine("LDList.stopBGA");
        LDList.runBGA=false;
        LoopControl.removeLoop("LDListBGA");
    }
}

//build event table
var EventList = new Object();

EventList.oDiv = null;
EventList.xml=null;
EventList.evHeight = null;
EventList.iEventStartID=-1;
EventList.MAX_LINE=20;
EventList.MSG_CLEAR_EVENT="Do you want to clear event?";
    
EventList.setXMLresult= function()
{
    if (EventList.xml != null)
    {    	
        EventList.oDiv.innerHTML = EventList.xml.responseText;
        ContentLoader.runScript(EventList.xml.responseText);
        
    	EventList.evHeight = document.getElementById("EvBody");
    }
    ContentLoader.returnBack(EventList.xml);
    EventList.xml=null;
}

EventList.run = function()
{
//start = -1 to get last 4 event
    var urlPath = "JumpPage.php?ra="+RefreshControl.getSeq()+"&Target=getEventList&start="+EventList.iEventStartID;
    ContentLoader.loadXMLDoc(EventList,urlPath);
    urlPath=null;
}

EventList.goFirstPage = function()
{
    EventList.iEventStartID = 0;
    EventList.run();
}

EventList.goLastPage = function()
{
    EventList.iEventStartID = -1;
    EventList.run();
}

EventList.goPrevPage = function(iStart)
{
    //event id start from 0
    EventList.iEventStartID = iStart - EventList.MAX_LINE - 1;
    if (EventList.iEventStartID<0) {EventList.iEventStartID=0}
    EventList.run();
}
EventList.goNextPage = function(iEnd,iLength)
{
    //event id start from 0
    EventList.iEventStartID = iEnd;
    if (EventList.iEventStartID>=iLength-EventList.MAX_LINE) {EventList.iEventStartID=iLength-EventList.MAX_LINE+1}
    EventList.run();
}

EventList.clearEvent = function()
{
    if (confirm(EventList.MSG_CLEAR_EVENT))
    {
        var clearCMD=new Command("command.php?cmdName=clearEvents");
        clearCMD.run();
        clearCMD=null;
    }
    return false;
}

EventList.saveEvent = function()
{
    var urlPath = "JumpPage.php?ra="+RefreshControl.getSeq()+"&Target=EventsSaveFilePage";
//    var win = null;
//    if (window.ActiveXObject)
//    {
//        win = window.open(urlPath,"SaveEvent","height=1,width=1,status=no,toolbar=no,menubar=no,location=no,top =1,left=1,titlebar=no");
//        win.moveTo(-10000,-10000);
//    }
//    else
//    {
//        win = window.open(urlPath,"Save Event","top=1,left=1,status=no,scrollbars=no,dialog=no,modal=no,width=1,height=1,resizable=no");
//        win.moveTo(self.outerWidth/2,self.outerHeight /2);
//    }
//    urlPath=null;

    //var oldPath = location.href;
    location = urlPath;
    //location = oldPath;
    urlPath=null;
}

function LDListPage()
{
    //link to ld ldlist
    LDList.oDiv=document.getElementById("LdListHtmlBody");
    RefreshControl.addFunction(LDList.eventListener,RefreshControl.LD_EVENT);

    //link to event list
    EventList.oDiv = document.getElementById("EventListHtmlBody");
    RefreshControl.addFunction(EventList.run,RefreshControl.ALL_EVENT);

    LoopControl.addLoop(RefreshControl.listenEvent,"RefreshControl.listenEvent");
    LoopControl.start();
}

function unLDListPage()
{
    LDList.oDiv=null;
    LDList=null;

    EventList.oDiv = null;
    EventList=null;
}

function goToCreate()
{
    window.location.href = "JumpPage.php?Target=CreatePage1&ra=" + RefreshControl.getSeq();
    return false;
}

function pageResize()
{
    pageFrame = document.getElementById("ldFrame");
    setWinWidth(pageFrame);
    var totalHeight = setWinHeight(pageFrame,108);
    var ldBodyHeight = (totalHeight - 140) * 0.5;
    LDList.oDiv.style.height = ldBodyHeight;
    EventList.oDiv.style.height = totalHeight - ldBodyHeight - 108;
}

function xmlPageResize()
{
    pageFrame = document.getElementById("ldFrame");
    EventList.evHeight = document.getElementById("EvBody");
    var totalHeight = setWinHeight(pageFrame,108);
    EventList.evHeight.style.height = (totalHeight - 190) * 0.5 + 2;
}

addResize(pageResize);
addResize(xmlPageResize);
addOnLoadListener(LDListPage);
addOnLoadListener(pageResize);
addUnLoad(unLDListPage);