<?php
class ActionInitLD extends UserAction 
{
	private $LD_ID;
	private $Type;
	
	protected function validatePara()
	{
		//check the http request parameters
	}
	protected function initActionPara()
	{
		$this->LD_ID = getRequestPara("LDID");
		$this->Init_Type = getRequestPara("InitType");
	}
	
	private function doInit()
	{
		$this->ApiCmd = new XMLAPICommand();
		$this->ApiCmd->setCommand(XMLAPICommand::MV_LD_StartINIT);
		$this->ApiCmd->setCommandPara("AdapterID",$this->getAdapterID());
		$this->ApiCmd->setCommandPara("LD_ID",$this->LD_ID);
		$this->ApiCmd->setCommandPara("Init_Type",$this->Init_Type);
		$this->ApiCmd->issueCommand();
		
		if ($this->ApiCmd->getResult()->RetVal . "") {
			$this->setLDCmdXmlRetFail();
		}
		else {
			$this->setLDCmdXmlRetSuccess();
		}
	}
	
	protected function doAction()
	{
		$this->doInit();
	}
}
?>