<?php

class XMLAPICommand
{
	const ParaALL = "255";
	const ParaUnknown = "127";
	
	const MV_LogonUser=
	"
	<MV_LogonUser type='function'>
	        <lpszUsername>%lpszUsername%</lpszUsername>
	        <lpszDomain>%lpszDomain%</lpszDomain>
	        <lpszPassword>%lpszPassword%</lpszPassword>
	</MV_LogonUser>
	";
	const MV_GetUserGroup=
	"
	<MV_GetUserGroup type='function'>
	        <lpszUsername>%lpszUsername%</lpszUsername>
	        <lpszDomain>%lpszDomain%</lpszDomain>
	</MV_GetUserGroup>
	";
	
	//bios flash related
	const MV_Flash_Option = 
	"
	<MV_Flash_Option type='function'>
	    <AdapterID>%AdapterID%</AdapterID>
	    <Actions>%Actions%</Actions>
	    <Type>%Type%</Type>
	    <filepath>%filepath%</filepath>
	</MV_Flash_Option>
	";
	
	const MV_BIOS_Version = 
	"
	<MV_BIOS_Version type='function'>
	    <filepath>%filepath%</filepath>
	</MV_BIOS_Version>
	";
	
	//DG Cmd
	
	const MV_DG_Create = 
	"
	<MV_DG_Create  type='function'>
		<AdapterID>%AdapterID%</AdapterID>
		<CreateOrModifyDGParam type='struct CreateOrModifyDGParam' >
			<Name type='U8'>%Name%</Name>
			<RaidMode type='MV_U8'>%RaidMode%</RaidMode>
			<SubVDCount type='MV_U8'>%SubVDCount%</SubVDCount>
			<NumParityDisk type='MV_U8'>%NumParityDisk%</NumParityDisk>
			<StripeBlockSize type='MV_U16'>%StripeBlockSize%</StripeBlockSize>
			<Size type='U64'>%Size%</Size>
			<BlockSize type='MV_U32'>%BlockSize%</BlockSize>
			<InitializationOption type='MV_U8'>%InitializationOption%</InitializationOption>
			<PDCount type='MV_U8'>%PDCount%</PDCount>
			<PDIDs type='U16'>%PDIDs%</PDIDs>
		</CreateOrModifyDGParam>
	</MV_DG_Create>
	";

	const MV_DG_GetSizeOnly = 
	"
	<MV_DG_GetSizeOnly  type='function'>
		<AdapterID>%AdapterID%</AdapterID>
		<CreateOrModifyDGParam type='struct CreateOrModifyDGParam' >
			<DGID type='MV_U16'>%DGID%</DGID>
			<Name type='U8'>%Name%</Name>
			<RaidMode type='MV_U8'>%RaidMode%</RaidMode>
			<SubVDCount type='MV_U8'>%SubVDCount%</SubVDCount>
			<NumParityDisk type='MV_U8'>%NumParityDisk%</NumParityDisk>
			<StripeBlockSize type='MV_U16'>%StripeBlockSize%</StripeBlockSize>
			<Size type='U64'>%Size%</Size>
			<BlockSize type='MV_U32'>%BlockSize%</BlockSize>
			<InitializationOption type='MV_U8'>%InitializationOption%</InitializationOption>
			<PDCount type='MV_U8'>%PDCount%</PDCount>
			<PDIDs type='U16'>%PDIDs%</PDIDs>
		</CreateOrModifyDGParam>
	</MV_DG_GetSizeOnly>
	";
	
    const MV_DG_Modify =
    "
    <MV_DG_Modify type='function'>
    	<AdapterID>%AdapterID%</AdapterID>
    	<CreateOrModifyDGParam type='struct CreateOrModifyDGParam'>
    		<DGID type='MV_U16'>%DGID%</DGID>
    		<Name type='U8'>%Name%</Name>
			<RaidMode type='MV_U8'>%RaidMode%</RaidMode>
			<SubVDCount type='MV_U8'>%SubVDCount%</SubVDCount>
			<NumParityDisk type='MV_U8'>%NumParityDisk%</NumParityDisk>
			<StripeBlockSize type='MV_U16'>%StripeBlockSize%</StripeBlockSize>
			<Size type='U64'>%Size%</Size>
			<BlockSize type='MV_U32'>%BlockSize%</BlockSize>
			<InitializationOption type='MV_U8'>%InitializationOption%</InitializationOption>
			<PDCount type='MV_U8'>%PDCount%</PDCount>
			<PDIDS type='U16'>%PDIDS%</PDIDS>
		</CreateOrModifyDGParam>
	</MV_DG_Modify>
	";	

	const MV_DG_GetInfo = 
	"
	<MV_DG_GetInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<DG_Info_Request type='struct DG_Info_Request'>
		    <RequestHeader type='struct RequestHeader'>
		      <requestType type='U8'>%requestType%</requestType>
		      <startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
		      <numRequested type='U16'>%numRequested%</numRequested>
		    </RequestHeader>
    	</DG_Info_Request>
	</MV_DG_GetInfo>
	";
	
	const MV_DG_Delete = 
	"
	<MV_DG_Delete type='function'>
		<AdapterID>%AdapterID%</AdapterID>
		<DG_ID type='MV_U16'>%DG_ID%</DG_ID>
	</MV_DG_Delete>
	";
	
	
    const MV_LD_DG_StartRebuild = 
	"
	<MV_LD_DG_StartRebuild type='function'>
		<AdapterID>%AdapterID%</AdapterID>
		<RebuildParam type='struct Rebuild_Param' >
			<ID type='MV_U16'>%ID%</ID>
			<RebuildType type='MV_U8'>%RebuildType%</RebuildType>
			<PDCount type='MV_U8'>%PDCount%</PDCount>
			<PDIDs type='U16'>%PDIDs%</PDIDs>
		</RebuildParam>
	</MV_LD_DG_StartRebuild>
	";
	
	const DG_StartConsistencyCheck = 
	"
	<MV_DG_StartConsistencyCheck type='function'>
		<AdapterID>%AdapterID%</AdapterID>
		<DG_ID type='MV_U16'>%DG_ID%</DG_ID>
		<Type type='MV_U8'>%Type%</Type>
	</MV_DG_StartConsistencyCheck>
	";
		
    const MV_DG_StartINIT = 
	"
	<MV_DG_StartINIT type='function'>
		<AdapterID>%AdapterID%</AdapterID>
		<DG_ID type='MV_U16'>%DG_ID%</DG_ID>
		<Init_Type type='MV_U8'>%Init_Type%</Init_Type>
	</MV_DG_StartINIT>
	";
	
 
    const MV_DG_StartMigration = 
	"
	<MV_DG_StartMigration type='function'>
		<AdapterID>%AdapterID%</AdapterID>
		<MigrateDG type='struct CreateOrModify_DG_Param' >
			<DGID type='MV_U16'>%DGID%</DGID>
			<RaidMode type='MV_U8'>%RaidMode%</RaidMode>
			<NumParityDisk type='MV_U8'>%NumParityDisk%</NumParityDisk>
			<PDCount type='MV_U8'>%PDCount%</PDCount>
			<PDIDs type='U16'>%PDIDs%</PDIDs>
		</MigrateDG>
	</MV_DG_StartMigration>
	";
	
    const MV_DG_BGAControl = 
	"
	<MV_DG_BGAControl type='function'>
		<AdapterID type='MV_U8'>%AdapterID%</AdapterID>
		<DG_ID type='MV_U16'>%DG_ID%</DG_ID>
		<Actions type='MV_U8'>%Actions%</Actions>
	</MV_DG_BGAControl>
	";
	
	const MV_DG_GetConfig=
	" 
    <MV_DG_GetConfig type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<DG_Config_Request type='struct DG_Config_Request'>
		    <RequestHeader type='struct RequestHeader'>
		      <requestType type='U8'>%requestType%</requestType>
		      <startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
		      <numRequested type='U16'>%numRequested%</numRequested>
		    </RequestHeader>
    	</DG_Config_Request>
    </MV_DG_GetConfig>
    ";
	
	const MV_DG_SetConfig = 
	" 
	<MV_DG_SetConfig type='function'>
   		<AdapterID type='MV_U8'>%AdapterID%</AdapterID>
		<DG_ID type='MV_U16'>%DGID%</DG_ID>
		<Config type='struct DG_Config'>
			<DGID type='MV_U16'>%DGID%</DGID>
			<Name type='MV_U16'>%Name%</Name>
			<WriteCacheOn type='MV_BOOLEAN'>%WriteCacheOn%</WriteCacheOn>
		</Config>
	</MV_DG_SetConfig>
	";
	
	const MV_LD_Create_OnDG = 
	"
	 <MV_LD_Create_OnDG type='function'>
   	     <AdapterID type='MV_U8'>%AdapterID%</AdapterID>
	     <CreateOrModifyVDParam type='struct Create_LD_Param'>
		    <DGID type='U16'>%DGID%</DGID>
		    <Name type='U8'>%Name%</Name>
		    <StripeBlockSize type='U16'>%StripeBlockSize%</StripeBlockSize>
		    <Size type='U64'>%Size%</Size>
		    <DGSlotNum type='U8'>%DGSlotNum%</DGSlotNum>		    
		    <RoundingScheme type='U8'>%RoundingScheme%</RoundingScheme>
		    <CachePolicy type='U8'>%CachePolicy%</CachePolicy>
		    <InitializationOption type='U8'>%InitializationOption%</InitializationOption>
		    <SectorCoefficient type='U8'>%SectorCoefficient%</SectorCoefficient>
		 </CreateOrModifyVDParam>
	</MV_LD_Create_OnDG>
	";
	//LD Cmd
	
	const MV_LD_GetStatus=
	" 
    <MV_LD_GetStatus type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<LD_Status_Request type='struct LD_Status_Request'>
		    <RequestHeader type='struct RequestHeader'>
		      <requestType type='U8'>%requestType%</requestType>
		      <startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
		      <numRequested type='U16'>%numRequested%</numRequested>
		    </RequestHeader>
    	</LD_Status_Request>
    </MV_LD_GetStatus>
    ";
	
	const MV_LD_GetConfig=
	" 
	<MV_LD_GetConfig type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<LD_Config_Request type='struct LD_Config_Request'>
		    <RequestHeader type='struct RequestHeader'>
		      <requestType type='U8'>%requestType%</requestType>
		      <startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
		      <numRequested type='U16'>%numRequested%</numRequested>
		    </RequestHeader>
		</LD_Config_Request>
	</MV_LD_GetConfig>
    ";
	
	const MV_LD_GetInfo = 
	"
	<MV_LD_GetInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<LD_Info_Request type='struct LD_Info_Request'>
		    <RequestHeader type='struct RequestHeader'>
		      <requestType type='U8'>%requestType%</requestType>
		      <startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
		      <numRequested type='U16'>%numRequested%</numRequested>
		    </RequestHeader>
  		</LD_Info_Request>
	</MV_LD_GetInfo>
	";
	
	const MV_LD_SetConfig = 
	" 
	<MV_LD_SetConfig type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<LD_ID type='U16'>%LD_ID%</LD_ID>
		<LDConfig type='struct LD_Config'>
			<CacheMode type='U8'>%CacheMode%</CacheMode>
			<AutoRebuildOn type='BOOL'>%AutoRebuildOn%</AutoRebuildOn>
			<Status type='U8'>%Status%</Status>
			<LDID type='U16'>%LDID%</LDID>
			<Name type='U8'>%Name%</Name>
		</LDConfig>
	</MV_LD_SetConfig>
	";
	
	const MV_LD_Import = 
	"
	<MV_LD_Import type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
  		<LD_ID type='U16'>%LD_ID%</LD_ID>
	</MV_LD_Import>
	"; 
	
	//HD
	
	const MV_PD_GetHDInfo =
	"
	<MV_PD_GetHDInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_Info_Request type='struct HD_Info_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</HD_Info_Request>
	</MV_PD_GetHDInfo>
	";
	
	const MV_PD_GetFreeSpaceInfo = 
	"
	<MV_PD_GetFreeSpaceInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_FreeSpaceInfo_Request type='struct HD_FreeSpaceInfo_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</HD_FreeSpaceInfo_Request>
	</MV_PD_GetFreeSpaceInfo>
	";
	
	const MV_PD_GetConfig = 
	" 
	<MV_PD_GetConfig type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_Config_Request type='struct HD_Config_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</HD_Config_Request>
	</MV_PD_GetConfig>
	";
	
	const MV_PD_GetRCT = 
	"
	<MV_PD_GetRCT type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID>%HD_ID%</HD_ID>
		<n type='U32'>%Num%</n>
		<s type='U32'>%Start%</s>
		<e type='U32'>%End%</e>
	</MV_PD_GetRCT>
	";
	
	const MV_PD_GetMPStatus = 
	" 
	<MV_PD_GetMPStatus type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_MP_Status_Request type='struct HD_MP_Status_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</HD_MP_Status_Request>
	</MV_PD_GetMPStatus>
	";
	
	const MV_PD_GetHDRaidStatus = 
	" 
	<MV_PD_GetHDRaidStatus type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_RAID_Status_Request type='struct HD_RAID_Status_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</HD_RAID_Status_Request>
	</MV_PD_GetHDRaidStatus>
	";
	
	const MV_PD_GetSmartStatus = 
	" 
	<MV_PD_GetSmartStatus type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_SMART_Status_Request type='struct HD_SMART_Status_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</HD_SMART_Status_Request>
	</MV_PD_GetSmartStatus>
	";
	
	
	const MV_PD_SetConfig = 
	" 
	<MV_PD_SetConfig type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <HD_ID type='U16'>%HD_ID%</HD_ID>
	  <Config type='struct HD_Config'>
	      <WriteCacheOn type='BOOL'>%WriteCacheOn%</WriteCacheOn>
	      <SMARTOn type='BOOL'>%SMARTOn%</SMARTOn>
	      <Online type='U8'>%Online%</Online>
	      <DriveSpeed type='U8'>%DriveSpeed%</DriveSpeed>
	      <HDID type='U16'>%HDID%</HDID>
	    </Config>
	</MV_PD_SetConfig>
	";
	
	const MV_PD_SetHDStatus = 
	"
	<MV_PD_SetHDStatus type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
		<Action type='U8'>%Action%</Action>
	</MV_PD_SetHDStatus>
	";
	
	const MV_PD_WipeHDMDD = 
	"
	<MV_PD_WipeHDMDD type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
		<Force type='U8'>%Force%</Force>
	</MV_PD_WipeHDMDD>
	"
	;
	
	//pd bga control
	const MV_PD_StartDataScrub = 
	"
	<MV_PD_StartDataScrub type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
	</MV_PD_StartDataScrub>
	"
	;
	
	const MV_PD_GetBGAStatus = 
	"
	<MV_PD_GetBGAStatus type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_BGA_Status_Request type='struct HD_BGA_Status'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</HD_BGA_Status_Request>
	</MV_PD_GetBGAStatus>
	"
	;
	
	const MV_PD_BGAControl = 
	"
	<MV_PD_BGAControl type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
		<Action type='U8'>%Action%</Action>
	</MV_PD_BGAControl>
	"
	;
	
	const MV_PD_StartMediaPatrol = 
	"
	<MV_PD_StartMediaPatrol type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <HD_ID type='U16'>%HD_ID%</HD_ID>
	</MV_PD_StartMediaPatrol>
	";
	
	const MV_LocateArrayDevice = 
	"
	<MV_LocateArrayDevice type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <deviceType type='U8'>%deviceType%</deviceType>
	  <deviceId type='U16'>%deviceId%</deviceId>
	  <ledStatus type='U8'>%ledStatus%</ledStatus>
	</MV_LocateArrayDevice>
	";
	
	//Encl
	
	const MV_ENC_GetEnclosureInfo =
	"
	<MV_ENC_GetEnclosureInfo type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <Enclosure_Info_Request type='struct Enclosure_Info_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
	  </Enclosure_Info_Request>
	</MV_ENC_GetEnclosureInfo>
	";
	
	const MV_ENC_GetElementInfo =
	"
	<MV_ENC_GetElementInfo type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <ENC_ID type='U16'>%ENC_ID%</ENC_ID>
	</MV_ENC_GetElementInfo>
	";
	
	const MV_ENC_GetElementConfig =
	"
	<MV_ENC_GetElementConfig type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <ENC_ID type='U16'>%ENC_ID%</ENC_ID>
	</MV_ENC_GetElementConfig>
	";
	
	const MV_ENC_SetElementConfig =
	"
	<MV_ENC_SetElementConfig type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <ENC_ID type='U16'>%ENC_ID%</ENC_ID>
	  <Config type='struct EncElement_Config'>
	      <type type='U8'>%type%</type>
	      <highCriticalThreshold type='U8'>%highCriticalThreshold%</highCriticalThreshold>
	      <highWarningThreshold type='U8'>%highWarningThreshold%</highWarningThreshold>
	      <lowCriticalThreshold type='U8'>%lowCriticalThreshold%</lowCriticalThreshold>
	      <lowWarningThreshold type='U8'>%lowWarningThreshold%</lowWarningThreshold>
	  </Config>
	</MV_ENC_SetElementConfig>
	";
	
	//block
	
	const MV_BLK_GetInfo = 
	"
	<MV_BLK_GetInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<Block_Info_Request type='struct Block_Info_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</Block_Info_Request>
	</MV_BLK_GetInfo>
	";
	
	//event
	
	const ZA_MV_EVT_GetEvents = 
	"
	<ZA_MV_EVT_GetEvents type='function'>
	  <n type='U32'>%Num%</n>
	  <s type='U32'>%Start%</s>
	  <e type='U32'>%End%</e>
	</ZA_MV_EVT_GetEvents>
	";
	
	const ZA_MV_EVT_GetChangeCounters = 
	"
	<ZA_MV_EVT_GetChangeCounters type='function'>
	</ZA_MV_EVT_GetChangeCounters>
	";
	
	const ZA_MV_EVT_Reset = 
	"
	<ZA_MV_EVT_Reset type='function'>
	</ZA_MV_EVT_Reset>
	";
	
	//HBA
	
	const MV_Adapter_GetInfo = 
	"
	<MV_Adapter_GetInfo type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	</MV_Adapter_GetInfo>
	";
	
	const MV_Adapter_GetConfig = 
	"<MV_Adapter_GetConfig type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
	</MV_Adapter_GetConfig>";
	
	const MV_Adapter_GetCount = 
	' 
	<MV_Adapter_GetCount type="function">
	</MV_Adapter_GetCount>
	';
	
	const MV_Adapter_SetConfig = 
	" 
	<MV_Adapter_SetConfig type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<AdapterConfig type='struct Adapter_Config_V2'>
			<AlarmOn type='BOOL'>%AlarmOn%</AlarmOn>
			<AutoRebuildOn type='BOOL'>%AutoRebuildOn%</AutoRebuildOn>
			<BGARate type='U8'>%BGARate%</BGARate>
			<PollSMARTStatus type='BOOL'>%PollSMARTStatus%</PollSMARTStatus>			
			<MediaPatrolRate type='BOOL'>%MediaPatrolRate%</MediaPatrolRate>
			<CopyBack type='BOOL'>%CopyBack%</CopyBack>
			<SyncRate type='U8'>%SyncRate%</SyncRate>
			<InitRate type='U8'>%InitRate%</InitRate>
			<RebuildRate type='U8'>%RebuildRate%</RebuildRate>
			<MigrationRate type='U8'>%MigrationRate%</MigrationRate>
			<CopybackRate type='U8'>%CopybackRate%</CopybackRate>
			<InterruptCoalescing type='BOOL'>%InterruptCoalescing%</InterruptCoalescing>
			<ModuleConsolidate type='BOOL'>%ModuleConsolidate%</ModuleConsolidate>
		</AdapterConfig>
	</MV_Adapter_SetConfig>
	";

	const MV_AdapterMute =
	'
	<MV_AdapterMute type="function">
            <AdapterID type="U8">%AdapterID%</AdapterID>
	</MV_AdapterMute>
	';

	const MV_BBU_SetThreshold = 
	" 
	<MV_BBU_SetThreshold  type='function'>
		<AdapterID type='MV_U8'>%AdapterID%</AdapterID>
		<tempLowerBound type='MV_U16'>%tempLowerBound%</tempLowerBound>
		<tempUpperBound type='MV_U16'>%tempUpperBound%</tempUpperBound>
		<volLowerBound type='MV_U16'>%volLowerBound%</volLowerBound>
		<volUpperBound type='MV_U16'>%volUpperBound%</volUpperBound>
	</MV_BBU_SetThreshold>
	";
	//bga
	const MV_LD_StartINIT = 
	" 
	<MV_LD_StartINIT type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <LD_ID type='U16'>%LD_ID%</LD_ID>
	  <Init_Type type='U8'>%Init_Type%</Init_Type>
	</MV_LD_StartINIT>
	";
	
	const MV_LD_BGAControl = 
	" 
	<MV_LD_BGAControl type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <LD_ID type='U16'>%LD_ID%</LD_ID>
	  <Actions type='U8'>%Actions%</Actions>
	</MV_LD_BGAControl>
	";
	
	//create ld
	
	const MV_LD_QuickCreate = 
	" 
	<MV_LD_QuickCreate type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<Type type='U8'>%Type%</Type>
	</MV_LD_QuickCreate>
	";
	const MV_LD_Create = 
	" 
	<MV_LD_Create type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<CreateLDParam type='struct Create_LD_Param'>
			<RaidMode type='U8'>%RaidMode%</RaidMode>
			<HDCount type='U8'>%HDCount%</HDCount>
			<RoundingScheme type='U8'>%RoundingScheme%</RoundingScheme>
			<SubLDCount type='U8'>%SubLDCount%</SubLDCount>
			<StripeBlockSize type='U16'>%StripeBlockSize%</StripeBlockSize>
			<Raid6Redundancy type='U8'>%Raid6Redundancy%</Raid6Redundancy>
			<CachePolicy type='U8'>%CachePolicy%</CachePolicy>
			<InitializationOption type='U8'>%InitializationOption%</InitializationOption>
			<HDIDs type='U16'>%HDIDs%</HDIDs>
			<NumParityDisk type='U8'>%NumParityDisk%</NumParityDisk>
			<SectorCoefficient  type='U8'>%SectorCoefficient%</SectorCoefficient>
			<Name type='U8'>%Name%</Name>
			<Size type='U64'>%Size%</Size>
		</CreateLDParam>
	</MV_LD_Create>
	";
	
	//delete ld
	const MV_LD_Delete =
	" 
	<MV_LD_Delete type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
	    <LD_ID type='U16'>%LD_ID%</LD_ID>
	    <deleteMBR type='U16'>%deleteMBR%</deleteMBR>
	</MV_LD_Delete>
	";
	
	const MV_LD_GetMaxSize = //StripeBlockSize??
	"
	<MV_LD_GetMaxSize type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<CreateLDParam type='struct Create_LD_Param'>
			<RaidMode type='U8'>%RaidMode%</RaidMode>
			<HDCount type='U8'>%HDCount%</HDCount>
			<RoundingScheme type='U8'>%RoundingScheme%</RoundingScheme>
			<SubLDCount type='U8'>%SubLDCount%</SubLDCount>
			<StripeBlockSize type='U16'>%StripeBlockSize%</StripeBlockSize>
			<Raid6Redundancy type='U8'>%Raid6Redundancy%</Raid6Redundancy>
			<CachePolicy type='U8'>%CachePolicy%</CachePolicy>
			<InitializationOption type='U8'>%InitializationOption%</InitializationOption>
			<SectorCoefficient  type='U8'>%SectorCoefficient%</SectorCoefficient>
			<NumParityDisk type='U8'>%NumParityDisk%</NumParityDisk>
			<HDIDs type='U16'>%HDIDs%</HDIDs>
			<Name type='U8'>%Name%</Name>
			<Size type='U64'>%Size%</Size>
		</CreateLDParam>
	</MV_LD_GetMaxSize>
	";
	
	const MV_LD_StartRebuild =
	"
	<MV_LD_StartRebuild type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <LD_ID type='U16'>%LD_ID%</LD_ID>
	  <Rebuild_HD_ID type='U8'>%Rebuild_HD_ID%</Rebuild_HD_ID>
	</MV_LD_StartRebuild>
	";
	
	const MV_LD_StartConsistencyCheck = 
	"
	<MV_LD_StartConsistencyCheck type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <LD_ID type='U16'>%LD_ID%</LD_ID>
	  <Type type='U8'>%Type%</Type>
	</MV_LD_StartConsistencyCheck>
	";
	
	const MV_LD_StartMigration = 
	"
	<MV_LD_StartMigration type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  <CreateLDParam type='struct Create_LD_Param'>
	    <RaidMode type='U8'>%RaidMode%</RaidMode>
	    <HDCount type='U8'>%HDCount%</HDCount>
	    <LDID type='U16'>%LDID%</LDID>
	    <HDIDs type='U16'>%HDIDs%</HDIDs>
	    <NumParityDisk type='U8'>%NumParityDisk%</NumParityDisk>
	  </CreateLDParam>
	</MV_LD_StartMigration>
	";
	
	const MV_LD_GetMigratedLdSize = 
	"
	<MV_LD_GetMigratedLdSize type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<CreateLDParam type='struct Create_LD_Param'>
			<RaidMode type='U8'>%RaidMode%</RaidMode>
			<HDCount type='U8'>%HDCount%</HDCount>
			<LDID type='U16'>%LDID%</LDID>
			<HDIDs type='U16'>%HDIDs%</HDIDs>
			<NumParityDisk type='U8'>%NumParityDisk%</NumParityDisk>
		</CreateLDParam>reateLDParam>
	</MV_LD_GetMigratedLdSize>
	";
	
	const MV_LD_GetTargetLDInfo = 
	"
	<MV_LD_GetTargetLDInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<LD_ID type='U16'>%LD_ID%</LD_ID>
	</MV_LD_GetTargetLDInfo>
	";
	
	//spare
	const MV_PD_Spare2FreeHD =
	" 
	<MV_PD_Spare2FreeHD type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
	</MV_PD_Spare2FreeHD>
	";
	
	const MV_PD_FreeHD2GlobalSpare =
	" 
	<MV_PD_FreeHD2GlobalSpare type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
	</MV_PD_FreeHD2GlobalSpare>
	";
	
	const MV_PD_FreeHD2DGSpare =
	" 
	<MV_PD_FreeHD2DGSpare type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
		<DG_ID type='U16'>%DG_ID%</DG_ID>
	</MV_PD_FreeHD2DGSpare>
	";
		
	const MV_PD_FreeHD2LDSpare = 
	"
	<MV_PD_FreeHD2LDSpare type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<HD_ID type='U16'>%HD_ID%</HD_ID>
		<LD_ID type='U16'>%LD_ID%</LD_ID>
	</MV_PD_FreeHD2LDSpare>
	";
	
	//expender
	const MV_PD_GetExpanderInfo = 
	"
	<MV_PD_GetExpanderInfo type='function'>
	  <AdapterID type='U8'>%AdapterID%</AdapterID>
	  	<Exp_Info_Request type='struct Exp_Info_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</Exp_Info_Request>
	</MV_PD_GetExpanderInfo>
	";
	
	//pm
	const MV_PD_GetPMInfo = 
	"
	<MV_PD_GetPMInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<PM_Info_Request type='struct PM_Info_Request'>
			<RequestHeader type='struct RequestHeader'>
				<requestType type='U8'>%requestType%</requestType>
				<startingIndexOrId type='U16'>%startingIndexOrId%</startingIndexOrId>
				<numRequested type='U16'>%numRequested%</numRequested>
			</RequestHeader>
		</PM_Info_Request>
	</MV_PD_GetPMInfo>
	";
	
	//BBU
	const MV_BBU_GetInfo = 
	"
	<MV_BBU_GetInfo type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
	</MV_BBU_GetInfo>
	";
	
	const MV_BBU_ActRelearn = 
	"
	<MV_BBU_ActRelearn type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
	</MV_BBU_ActRelearn>
	";
	/*
	const MV_BBU_SetMaxCapacity = 
	"
	<MV_BBU_SetMaxCapacity type='function'>	
		<AdapterID type='U8'>%AdapterID%</AdapterID>	
		<BBU_ID type='U16'>%BBU_ID%</BBU_ID>
		<maxCapacity type='MV_U16'>%maxCapacity%</maxCapacity>
	</MV_BBU_SetMaxCapacity>
	";
	*/
	//system 
	const  MV_SetDriverMode = 
	"
	<MV_SetDriverMode type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
		<Mode type='U32'>%Mode%</Mode>
	</MV_SetDriverMode>
	";
	
	const MV_GetDriverMode = 
	"
	<MV_GetDriverMode type='function'>
		<AdapterID type='U8'>%AdapterID%</AdapterID>
	</MV_GetDriverMode>
	";
	
	const ZA_Module_GetInfo = 
	"
    <ZA_Module_GetInfo type='function'>
    </ZA_Module_GetInfo>
    ";
	
	
	const MV_API_Version = 
	"
	<MV_API_Version type='function'>
	</MV_API_Version>
	";
	
	
	const MV_GetUserName = 
	"
	<MV_GetUserName type='function'>
	</MV_GetUserName>
	";
	private $Command;
	private $Result;	
	private $xmlHandler;
		
	public function setCommand($Command)
	{
		$this->Command = $Command;
	}
	
	public function getCommand()
	{
		return $this->Command;
	}
	
	public function setCommandPara($paraName,$paraVal)
	{
		$this->Command = str_ireplace("%" . $paraName .  "%","" . $paraVal,$this->Command);
		if (($prePos = strpos($this->Command, "<" . $paraName)) !== false) {
			if (($postPos = strpos($this->Command, "</" . $paraName)) !== false) {
				$sub1 = substr($this->Command, 0, $prePos+1);
				$sub2 = substr($this->Command, $postPos);
				$this->Command = $sub1 . $paraName . ">" . $paraVal . $sub2;
			}
		}
	}
	
	//issue Command
	public function issueCommand()
	{
		if( strpos($this->Command,"%"))
			return false;
		$XMLRet = false;
		
		try {
			if (!zRaidApi( $this->Command, $XMLRet ))
				return false;
			$len = strlen($XMLRet);
			$newXMLRet = "";
			for ($i = 0; $i < $len; $i++)
			{
				$ch = $XMLRet{$i};
				if ( ord($ch) <= 31 || ord($ch) >= 127) {
					$ch = '';
				}
				
				$newXMLRet .= $ch;
			}
			$this->Result = new SimpleXMLElement($newXMLRet);
			
			$retVal = intval($this->Result->RetVal);
			
			if($retVal == 0 && isset($this->xmlHandler))
			{
				$this->xmlHandler->handle($this->Result);
			}
		}
		catch (Exception $e)
		{
			//var_dump($XMLRet);
		}
		
		return true;
	}
	
	//for debug
	public function setResult($Result)
	{
		$this->Result = $Result;
	}
	//for debug
	
	public function getResult()
	{
		return $this->Result;
	}
	
	public function setXmlHandler($handler)
	{
		$this->xmlHandler = $handler;
	}
	
	public function getXmlHandler()
	{
		return $this->xmlHandler;
	}
}
?>