<?php

//include_once("CtnHdList.class.php");
include_once("../phpsrc/baseclass/HBADetail.class.php");

class CtnMigrateLdHdList extends CtnHdList 
{
	private $migrateSize;
	private $LDMemberHDs = array();
	
	public function setMigrateSize($migrateSize)
	{
		$this->migrateSize = $migrateSize;
	}
	
	public function addLDMemberHD($HD)
	{
		$this->LDMemberHDs[] = $HD;
	}
	
	protected function setDataToPage()
	{
		$hdList = array();
		$baseclasses = $this->base->getBaseClasses();
		
		foreach ($baseclasses as $HD)
		{
			$HBADetail = new HBADetail();
		    $HBADetail->setID($HD->getAdapterID());
	    	$HBADetail->toGetHBAInfo();
	    	$HBADetail->initData();
    		$hbabaseclasses = $HBADetail->getBaseClasses();

			if ($this->migrateSize <= $HD->getValidSize()
				&& (($HD->isFree() || $hbabaseclasses[0]->getDevID() < 0x6400))
				&& ($HD->canLogicalUsed())
				&& (! $HD->isOffline()) 
				&& (! $HD->isSpare())) {
				
				$notfound = true;
				foreach ($this->LDMemberHDs as $HDInfo)
				{
					if ($HD->getDeviceID() == $HDInfo->getDeviceID()) {
						$notfound = false;
						break;
					}
				}
				if ($notfound) {
					$HDInfo = new HDInfo();
					$HDInfo->setHDInfo($HD);
					
					if ($this->AdapterID == XMLAPICommand::ParaALL || trim($HDInfo->AdapterID) == trim($this->AdapterID)) 
					{
						$hdList[$HDInfo->ID] = $HDInfo;
					}
				}
			}
		}
		
		ksort($hdList);
		
		$this->smarty->assign("MigratePdList",$hdList);
	}
}


?>