<?php
include_once("../phpsrc/Common.php");
include_once("../phpsrc/common_smarty.php");

include_once("../phpsrc/baseclass/Device.class.php");
include_once("../phpsrc/baseclass/SASAddress.class.php");
include_once("../phpsrc/baseclass/SASDevice.class.php");
include_once("../phpsrc/baseclass/Port.class.php");
include_once("../phpsrc/baseclass/Link.class.php");
include_once("../phpsrc/baseclass/PortDevice.class.php");
include_once("../phpsrc/baseclass/Block.class.php");
include_once("../phpsrc/baseclass/PM.class.php");
include_once("../phpsrc/baseclass/ExpanderDevice.class.php");
include_once("../phpsrc/baseclass/RCTRecord.class.php");
include_once("../phpsrc/baseclass/HD.class.php");
include_once("../phpsrc/baseclass/DG.class.php");
include_once("../phpsrc/baseclass/LD.class.php");
include_once("../phpsrc/baseclass/LdOnDg.class.php");
include_once("../phpsrc/baseclass/Event.class.php");
include_once("../phpsrc/baseclass/HBA.class.php");
include_once("../phpsrc/baseclass/System.class.php");
include_once("../phpsrc/baseclass/Encl.class.php");
include_once("../phpsrc/baseclass/BBU.class.php");

include_once("../phpsrc/baseclass/DeviceFactory.class.php");

include_once("../phpsrc/baseclass/XMLAPICommand.class.php");
include_once("../phpsrc/baseclass/RequestSender.class.php");
include_once("../phpsrc/baseclass/BaseMultiRequestSender.class.php");
include_once("../phpsrc/baseclass/BaseSingleRequestSender.class.php");

include_once("../phpsrc/baseclass/XmlHandler.class.php");
include_once("../phpsrc/baseclass/DgXmlHandler.class.php");
include_once("../phpsrc/baseclass/EncXmlHandler.class.php");
include_once("../phpsrc/baseclass/ExpXmlHandler.class.php");
include_once("../phpsrc/baseclass/HdXmlHandler.class.php");
include_once("../phpsrc/baseclass/LdXmlHandler.class.php");
include_once("../phpsrc/baseclass/PMXmlHandler.class.php");
include_once("../phpsrc/baseclass/BBUXmlHandler.class.php");

include_once("../phpsrc/baseclass/BaseFactory.class.php");
include_once("../phpsrc/baseclass/ExpanderBase.class.php");
include_once("../phpsrc/baseclass/PMBase.class.php");
include_once("../phpsrc/baseclass/HdBase.class.php");
include_once("../phpsrc/baseclass/DgBase.class.php");
include_once("../phpsrc/baseclass/LdBase.class.php");
include_once("../phpsrc/baseclass/EnclBase.class.php");

include_once("../phpsrc/baseclass/BlockList.class.php");
include_once("../phpsrc/baseclass/DgList.class.php");
include_once("../phpsrc/baseclass/DgDetail.class.php");
include_once("../phpsrc/baseclass/LdList.class.php");
include_once("../phpsrc/baseclass/LdDetail.class.php");
include_once("../phpsrc/baseclass/LdOnDgList.class.php");
include_once("../phpsrc/baseclass/LdOnDgDetail.class.php");
include_once("../phpsrc/baseclass/HdList.class.php");
include_once("../phpsrc/baseclass/EnclElement.class.php");
include_once("../phpsrc/baseclass/EnclList.class.php");
include_once("../phpsrc/baseclass/EnclDetail.class.php");
include_once("../phpsrc/baseclass/PMList.class.php");
include_once("../phpsrc/baseclass/PMDetail.class.php");
include_once("../phpsrc/baseclass/ExpanderList.class.php");
include_once("../phpsrc/baseclass/ExpanderDetail.class.php");
include_once("../phpsrc/baseclass/HdDetail.class.php");

include_once("../phpsrc/baseclass/BaseData.class.php");
include_once("../phpsrc/baseclass/HBABase.class.php");
include_once("../phpsrc/baseclass/EventList.class.php");
include_once("../phpsrc/baseclass/RCTRecordList.class.php");
include_once("../phpsrc/baseclass/CreateLDMaxSize.class.php");
include_once("../phpsrc/baseclass/HBADetail.class.php");
include_once("../phpsrc/baseclass/HBAList.class.php");
include_once("../phpsrc/baseclass/SystemDetail.class.php");
include_once("../phpsrc/baseclass/BBUBase.class.php");
include_once("../phpsrc/baseclass/BBUDetail.class.php");

include_once("../phpsrc/baseclass/DataAccess.class.php");
include_once("../phpsrc/baseclass/XMLDataAccess.class.php");

include_once("../phpsrc/baseclass/User.class.php");
include_once("../phpsrc/baseclass/BGAJob.class.php");
include_once("../phpsrc/baseclass/SystemSetting.class.php");

include_once("../phpsrc/baseclass/UserDataAccess.class.php");
include_once("../phpsrc/baseclass/BGAJobDataAccess.class.php");
include_once("../phpsrc/baseclass/SystemSettingDataAccess.class.php");

include_once("../phpsrc/container/Pager.class.php");
include_once("../phpsrc/container/CtnUsers.class.php");
include_once("../phpsrc/container/CtnBGASchedule.class.php");

include_once("../phpsrc/container/DevInfo.class.php");
include_once("../phpsrc/container/HDInfo.class.php");
include_once("../phpsrc/container/EnclInfo.class.php");
include_once("../phpsrc/container/DGInfo.class.php");
include_once("../phpsrc/container/LDInfo.class.php");
include_once("../phpsrc/container/LdOnDgInfo.class.php");
include_once("../phpsrc/container/PMInfo.class.php");
include_once("../phpsrc/container/ExpanderInfo.class.php");
include_once("../phpsrc/container/HBAInfo.class.php");
include_once("../phpsrc/container/BBUInfo.class.php");

include_once("../phpsrc/container/Container.class.php");
include_once("../phpsrc/container/CtnBBUDetail.class.php");
include_once("../phpsrc/container/CtnEnclList.class.php");
include_once("../phpsrc/container/CtnEnclDetail.class.php");
include_once("../phpsrc/container/CtnDgList.class.php");
include_once("../phpsrc/container/CtnDgDetail.class.php");
include_once("../phpsrc/container/CtnLdList.class.php");
include_once("../phpsrc/container/CtnLdDetail.class.php");
include_once("../phpsrc/container/CtnLdOnDg.class.php");
include_once("../phpsrc/container/CtnLdOnDgList.class.php");
include_once("../phpsrc/container/CtnEventList.class.php");
include_once("../phpsrc/container/CtnHdList.class.php");
include_once("../phpsrc/container/CtnRCTRecordList.class.php");
include_once("../phpsrc/container/CtnHdDetail.class.php");
include_once("../phpsrc/container/CtnPdOnDgInfo.class.php");
include_once("../phpsrc/container/CtnCreateLDMaxSize.class.php");
//include_once("../phpsrc/container/CtnPMList.class.php");
//include_once("../phpsrc/container/CtnPMDetail.class.php");
//include_once("../phpsrc/container/CtnExpanderList.class.php");
//include_once("../phpsrc/container/CtnExpanderDetail.class.php");
include_once("../phpsrc/container/CtnHBADetail.class.php");
include_once("../phpsrc/container/CtnHBAList.class.php");
include_once("../phpsrc/container/CtnSystemDetail.class.php");
include_once("../phpsrc/container/Filters.class.php");

include_once("../phpsrc/pagedisplayer/PageDisplayer.class.php");
include_once("../phpsrc/pagedisplayer/BGAPageDisplayer.class.php");
include_once("../phpsrc/pagedisplayer/CtnDisplayer.class.php");

include_once("../phpsrc/Util.php");

include_once("../phpsrc/localization.php");
?>
