<?php
class CtnIndependentVDPageDisplayer extends CtnDisplayer {
	protected function initPage()
	{
		$smarty = $this->smarty;
		
 	  	$wBack = gettext("Write Back(Performance)");
	    $wThru = gettext("Write Through(Reliable)");
	    $rAhead = gettext("Read Ahead");
	    $rNone = gettext("No Read Ahead");
		$wCacheOptions = 
			array(
				LDCacheMode::WRITEBACK_ENABLE=>$wBack,
				LDCacheMode::WRITETHRU_ENABLE =>$wThru   //default value
			);
		
		$rCacheOptions = 
			array(
				LDCacheMode::LOOKAHEAD_ENABLE =>$rAhead,   //default value
				0 =>$rNone
			);
			
		$smarty->assign("wCacheOptions",$wCacheOptions);
		$smarty->assign("rCacheOptions",$rCacheOptions);
		
		$ID = getRequestPara("ID");
		$HBAID = getRequestPara("HBAID");
		
		$container = new CtnLdDetail();
		$container->setAdapterID($HBAID);
		$container->setLDID($ID);
		$container->toGetLDInfo();
		$container->toGetLDConfig();
		$container->toGetLDStatus();
		$hba = HBAFactory::getInstance($HBAID);
		if($hba && $hba->supportMigration())
		{
			$container->toGetTargetLDInfo();
		}
		$container->smartyAssign($smarty);
		$container->initContainer();
		
		$this->setPageName("XML_IndependentVDPage.tpl");
	}
}

?>