<?php
class CtnSystemSubPageDisplayer extends CtnDisplayer {
	protected function initPage()
	{
		$smarty = $this->smarty;
		
		$SysDtl = new CtnSystemDetail();
		$SysDtl->toGetAPIVer();
		$SysDtl->toGetSysInfo();
		$SysDtl->smartyAssign($smarty);
		$SysDtl->initContainer();
		
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
		{			
			$HostName = getenv('COMPUTERNAME');
			$HostIP = gethostbyname($HostName);
		}
		else
		{			
			$HostIP = apache_getenv('SERVER_ADDR');
			$HostName = exec("hostname");
		}
		
		$smarty->assign("HostName", $HostName);
		$smarty->assign("HostIP", $HostIP);
				
		$this->setPageName("XML_SystemSubPage.tpl");
	}
}

?>