<?php
//include_once("PageDisplayer.class.php");

class PgEnclDtlDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		$smarty = $this->smarty;
		$EnclID = getRequestPara('ID');
		
		if ($EnclID === null) {
			$this->displayDefaultPage(Target::EnclosureListPage);
			return;
		}
    	
		$EnclList = new EnclList();
		$EnclList->toGetEnclInfo();
		$EnclList->toGetEnclExpanderInfo();
		$EnclList->toGetEnclPMInfo();
		$EnclList->initData();
		$validEncls = $EnclList->getBaseClasses();
		$isValid = 0;
		foreach ($validEncls as $Encls)
		{
			if ($Encls->getID() == $EnclID)
			{
				$isValid = 1;
			}
		}
		if (!$isValid)
		{
			$this->displayDefaultPage(Target::EnclosureListPage);
			return ;
		}
		
		$smarty->assign("EnclID", $EnclID);	
		$this->setPageName(Target::EnclosureDetailPage . ".tpl");
	}
}
?>