<?php
//include_once("PageDisplayer.class.php");

class PgExpDtlDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		$smarty = $this->smarty;
		$ExpID = getRequestPara('ID');
		
		if ($ExpID == null) {
			$this->displayDefaultPage(Target::ExpanderListPage);
			return;
		}
    		
		$smarty->assign("ExpID", $ExpID);
		
		//check whether expander exists
		$ExpList = new ExpanderList();
		$ExpList->initData();
		$validExps = $ExpList->getBaseClasses();
		$isValid = 0;
		foreach ($validExps as $Exp)
		{
			if ($Exp->getDeviceID() == $ExpID)
			{
				$isValid = 1;
				break;
			}
		}
		if (!$isValid)
		{
			$this->displayDefaultPage(Target::ExpanderListPage);
			return ;
		}
		
		$this->setPageName(Target::ExpanderDetailPage . ".tpl");
	}
}
?>