<?php
//include_once("PageDisplayer.class.php");

class PgLdListDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		$smarty = $this->smarty;
		
		$HBAList = new HBAList();
		$HBAList->toGetHBACount();
		$HBAList->toGetHBAInfo();
		$HBAList->initData();
		
		$count = sizeof($HBAList->getBaseClasses());
				
		$enableCreateBtn = 0;
		
		if ($count && getSessionPara('isAdmin')) {
			$hbalist = $HBAList->getBaseClasses();
			
			$LdList = new LDList();
			$LdList->toGetLDInfo();
			$LdList->initData();
			$LDNum = sizeof($LdList->getBaseClasses());
			
			$maxRaidNum = 0;
			$notNonRaid = 0;
			foreach ($hbalist as $hba)
			{
				$maxRaidNum += $hba->getMaxLogicalDrive();
				if ($hba->getLogicalDriverMode()) {
					$notNonRaid = 1;
				}
			}
			
			if ($maxRaidNum > $LDNum && $notNonRaid) {
				$enableCreateBtn = 1;
			}
		}
		
		$smarty->assign("enableCreateBtn",$enableCreateBtn);
		
		$this->setPageName(Target::LdListPage . ".tpl");
	}
}
?>