<?php
//include_once("PageDisplayer.class.php");

class PgNewTimesettingDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		$smarty = $this->smarty;
		
		$VdNotOnDg = getRequestPara('VdNotOnDg');
		$type = getRequestPara('type');
		$jobID = getRequestPara('jobID');
		$cmdPara = getRequestPara('cmdPara');
		$pageID = getRequestPara('pageID');
		$VDID = getRequestPara('VDID');
		$bgaType = getRequestPara('bgaType');
		$startTime= getRequestPara('startTime');
		$repeatType= getRequestPara('repeatType');
		$repeatParam1= getRequestPara('repeatParam1');
		$repeatParam2= getRequestPara('repeatParam2');
		$bgaPage = getRequestPara('bgaPage');
    	$CancelAlert = gettext(AlertMsg::SCHEDULE_CANCEL)."?";
    	
    	if ($type == 'saveModify' && $cmdPara == null) {
			$da = new BGAJobDataAccess();
			$job = $da->getBGAJobByID($jobID);
			
			if ($job) {
				//get job info
				$cmdPara = $job->getCmdPara();
				$bgaType = $job->getBgaType();
				
				$VDID = $job->getVDID();
				$startTime = $job->getSettingTime();
				$repeatParam1 = $job->getSettingDate();
				$repeatParam2 = $job->getSettingDateSupplement();
				$repeatType = $job->getSettingType();
				
				//format display
				$startTime = substr($startTime,0,2) . ':' . substr($startTime,2,2);
				if ($repeatType == ScheduleSettingType::No_REPEAT) {
					$time  = strtotime($repeatParam1);
					$repeatParam1 = date('m/d/Y',$time);
				}
			}
			else
			{
				$this->displayDefaultPage(Target::BgaSchedulePage);
			}
		}
    	
    	if ($bgaType == ScheduledBGAType::LD_BGA_CONSISTENCY_CHECK 
    			|| $bgaType == ScheduledBGAType::LD_BGA_CONSISTENCY_FIX
    			|| $bgaType == ScheduledBGAType::HD_BGA_MP
    			//|| $bgaType == ScheduledBGAType::DG_BGA_CONSISTENCY_CHECK 
    			//|| $bgaType == ScheduledBGAType::DG_BGA_CONSISTENCY_FIX 
    	)
    	{
    		//if is check bga,the bga can repeated
    		$notCheckBga = 0;
    	}
    	else 
    	{
    		$notCheckBga = 1;
    	}
    	
    	$now = getNow();
    	$nowTime = strtotime($now);
    	$nowDateStr = date('m/d/Y',$nowTime);
    	$nowTimeStr = date('H:i',$nowTime);
    	$smarty->assign('nowDateStr',$nowDateStr);
    	$smarty->assign('nowTimeStr',$nowTimeStr);
    	
		//$smarty->assign("isDGBGA", 1);
    	$smarty->assign('VDID',$VDID);
    	$smarty->assign('type',$type);
		$smarty->assign('pageID',$pageID);
		$smarty->assign('jobID',$jobID);
		$smarty->assign('cmdPara',$cmdPara);
		$smarty->assign('ID',$VDID);
		$smarty->assign('bgaType',$bgaType);
		$smarty->assign('startTime',$startTime);
		$smarty->assign('repeatType',$repeatType);
		$smarty->assign('repeatParam1',$repeatParam1);
		$smarty->assign('repeatParam2',$repeatParam2);
        $smarty->assign('bgaPage',$bgaPage);
        $smarty->assign("CancelAlert",$CancelAlert);
        
        $smarty->assign("notCheckBga",$notCheckBga);
        
    	if ($VdNotOnDg) {
    		$container = new CtnLdDetail();
    		$smarty->assign("VdNotOnDg",$VdNotOnDg);
    	} else {
			$container = new CtnLdOnDg();
    	}
		$container->setLDID($VDID);
		$container->toGetLDInfo();
		$container->toGetLDConfig();
		$container->toGetLDStatus();
		$container->smartyAssign($smarty);
		$container->initContainer();
		
		//to generate calendar main body
		$Calendar_Part="";
		for($x=0; $x<5; $x++){
			$Calendar_Part .= "<tr>";
			for($y=0; $y<7; $y++)
			{
				$Calendar_Part .= "<td class='out' id='calDay" . ($x*7+$y) . "' >.</td>"; 
			}
			$Calendar_Part .= "</tr>";
		}
		 
		$Calendar_Part .= "<tr>";
		for($z=35; $z<39; $z++) $Calendar_Part .= "<td class='out' id='calDay" .  $z  . "'>.</td>";
		//var_dump($Calendar_Part);
        $smarty->assign("Calendar_Part",$Calendar_Part);
		$this->setPageName(Target::NewTimesettingPage . ".tpl");
	}
}
?>