<?php
class ActionCheckLD extends UserAction 
{
	private $LD_ID;
	private $Type;
	
	protected function validatePara()
	{
		//check the http request parameters
	}
	protected function initActionPara()
	{
		$this->LD_ID = getRequestPara("LDID");
		$this->Type = getRequestPara("CheckType");
	}
	
	private function doCheckAndFix()
	{
		$this->ApiCmd = new XMLAPICommand();
		$this->ApiCmd->setCommand(XMLAPICommand::MV_LD_StartConsistencyCheck);
		$this->ApiCmd->setCommandPara("AdapterID",$this->getAdapterID());
		$this->ApiCmd->setCommandPara("LD_ID",$this->LD_ID);
		$this->ApiCmd->setCommandPara("Type",$this->Type);
		$this->ApiCmd->issueCommand();
		
		if ($this->ApiCmd->getResult()->RetVal . "") {
			$this->setLDCmdXmlRetFail();
		}
		else {
			$this->setLDCmdXmlRetSuccess();
		}
	}
	
	protected function doAction()
	{
		$this->doCheckAndFix();
	}
}
?>