<?php
class ActionClearSpare extends UserAction 
{
	private $HD_ID;
	
	protected function validatePara()
	{
		//check the http request parameters
	}
	protected function initActionPara()
	{
		$this->HD_ID = getRequestPara("HDID");
	}
	
	private function doClearSpare()
	{
		$this->ApiCmd = new XMLAPICommand();
		$this->ApiCmd->setCommand(XMLAPICommand::MV_PD_Spare2FreeHD);
		$this->ApiCmd->setCommandPara("AdapterID",$this->getAdapterID());
		$this->ApiCmd->setCommandPara("HD_ID",$this->HD_ID);
		$this->ApiCmd->issueCommand();
		
		if ($this->ApiCmd->getResult()->RetVal . "") {
			$this->setHDCmdXmlRetFail();
		}
		else {
			$this->setHDCmdXmlRetSuccess();
		}
	}
	
	protected function doAction()
	{
		$this->doClearSpare();
	}
}
?>