<?php
class ActionRebuildDG extends UserAction 
{
	private $DG_ID = 0;
	private $Rebuild_Type=2;//rebuild dg: 2,rebuild vd: 1
	private $Rebuild_HDCount=0;
	private $Rebuild_HD_ID;
	
	protected function validatePara()
	{
		//check the http request parameters
	}
	protected function initActionPara()
	{
		$this->DG_ID = getRequestPara("DGID");
	//	$this->Rebuild_Type = getRequestPara("RebuildType");
	//	$this->Rebuild_HDCount = getRequestPara("HDCount");
		$this->Rebuild_HD_ID = getRequestPara("HDID");
	}
	
	private function doRebuild()
	{
		$this->ApiCmd = new XMLAPICommand();
		$this->ApiCmd->setCommand(XMLAPICommand::MV_LD_DG_StartRebuild);
		$this->ApiCmd->setCommandPara("AdapterID",$this->getAdapterID());
		$this->ApiCmd->setCommandPara("ID",$this->DG_ID);
		$this->ApiCmd->setCommandPara("RebuildType",$this->Rebuild_Type);
		
		//Rebuild_HDCount
		$hds = explode(" ",$this->Rebuild_HD_ID);
		foreach ($hds as $Hd)
		{
			if (trim($Hd) != "") {
				$this->Rebuild_HDCount ++;
			}
		}
		$this->ApiCmd->setCommandPara("PDCount",$this->Rebuild_HDCount);
		$this->ApiCmd->setCommandPara("PDIDs",$this->Rebuild_HD_ID);
		
		$this->ApiCmd->issueCommand();
		
		if ($this->ApiCmd->getResult()->RetVal . "") {
			$this->setDGCmdXmlRetFail();
		}
		else {
			$this->setDGCmdXmlRetSuccess();
		}
	}
	
	protected function doAction()
	{
		$this->doRebuild();
	}
}
?>