<?php
class ActionRebuildLD extends UserAction 
{
	private $LD_ID;
	private $Rebuild_HD_ID;
	
	protected function validatePara()
	{
		//check the http request parameters
	}
	protected function initActionPara()
	{
		$this->LD_ID = getRequestPara("LDID");
		$this->Rebuild_HD_ID = getRequestPara("HDID");
	}
	
	private function doRebuild()
	{
		$this->ApiCmd = new XMLAPICommand();
		$this->ApiCmd->setCommand(XMLAPICommand::MV_LD_StartRebuild);
		$this->ApiCmd->setCommandPara("AdapterID",$this->getAdapterID());
		$this->ApiCmd->setCommandPara("LD_ID",$this->LD_ID);
		$this->ApiCmd->setCommandPara("Rebuild_HD_ID",$this->Rebuild_HD_ID);
		$this->ApiCmd->issueCommand();
		
		if ($this->ApiCmd->getResult()->RetVal . "") {
			$this->setLDCmdXmlRetFail();
		}
		else {
			$this->setLDCmdXmlRetSuccess();
		}
	}
	
	protected function doAction()
	{
		$this->doRebuild();
	}
}
?>