<?php
//include_once("PageDisplayer.class.php");

class PgEmailSettingDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		if (!getSessionPara('isAdmin')) 
		{
	        $this->displayDefaultPage(Target::LoginPage);
	        return;
		} 
		
		$da = new SystemSettingDataAccess();
		$sysSetting = $da->getSystemSetting();
		
		$IPAddress = trim(getRequestPara('IPAddress'));
		$portNum = trim(getRequestPara('portNum'));
		$userName = trim(getRequestPara('userName'));
		$Password = trim(getRequestPara('passWord'));
		$isSSL = trim(getRequestPara('cSSL'));
		$update = trim(getRequestPara('update'));
		$da = new SystemSettingDataAccess();
		
		if ($IPAddress) 
		{
			if ($isSSL) {
				$isSSL = 1;
			}
			$da->updateMailSetting($userName,$Password,$portNum,$IPAddress,$isSSL);
			//modify
			$this->jumptoPage('Target=EmailSettingPage&update=1');
		}
		else {
			//display 
			$sysSetting = $da->getSystemSetting();
			if ($sysSetting) {
				$userName = $sysSetting->getUserName();
				$Password = $sysSetting->getPasswd();
				$portNum = $sysSetting->getPort();
				$IPAddress = $sysSetting->getServerAddr();
				$isSSL = $sysSetting->isSSL();
			}
			$this->smarty->assign('IPAddress',$IPAddress);
			$this->smarty->assign('isSSL',$isSSL);
			$this->smarty->assign('portNum',$portNum);
			$this->smarty->assign('userName',$userName);
			$this->smarty->assign('Password',$Password);
			$this->smarty->assign('update',$update);
		}		
		
		$this->setPageName(Target::EmailSettingPage . ".tpl");
	}
}
?>