<?php
//include_once("PageDisplayer.class.php");

class PgPMDtlDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		$smarty = $this->smarty;
		$PMID = getRequestPara('ID');
		
		if ($PMID == null) {
			$this->displayDefaultPage(Target::PMListPage);
			return;
		}
    		
		$smarty->assign("PMID", $PMID);
		
		$pmlist = new CtnPMList();
		$pmlist->smartyAssign($smarty);
		$pmlist->initContainer();
		
		//check whether pm exists
		$validPMs = $pmlist->getBase()->getBaseClasses();
		$isValid = 0;
		foreach ($validPMs as $PM)
		{
			if ($PM->getDeviceID() == $PMID)
			{
				$isValid = 1;
				break;
			}
		}
		if (!$isValid)
		{
			$this->displayDefaultPage(Target::PMListPage);
			return ;
		}
		
		$pmDtl = new CtnPMDetail();
		$pmDtl->setID($PMID);
		$pmDtl->smartyAssign($smarty);
		$pmDtl->initContainer();
		
		$this->setPageName(Target::PMDetailPage . ".tpl");
	}
}
?>